\begin{lstlisting}[style=Java, caption=AJAX-Event-Methoden der MindMapView Klasse, label=code:mindmap-view]
@Named @ViewScoped
public class MindmapView implements Serializable {
    ...
    public void onNodeSelect(SelectEvent event) {
        MindmapNode node = (MindmapNode) event.getObject();
        if (!node.getChildren().isEmpty()) return;
        site = siteService.getById(site.getId());

        Object o = node.getLabel();
        for (NetworkComponent c : site.getTopology().getComponents()) {
            if (isType(o, c, "ROUTER", ComponentType.ROUTER) ||
                    isType(o, c, "SWITCH", ComponentType.SWITCH) ||
                    isType(o, c, "CLIENT", ComponentType.CLIENT)) {
                node.addNode(createChild(c.getHostname(), c));
            } else if (o.equals("IPs")) {
                node.addNode(createChild(c.getIp(), c));
            }
        }
    }
    public void onNodeDblselect(SelectEvent event) {
        this.selectedNode = (MindmapNode) event.getObject();
    }
    private boolean isType(Object o, NetworkComponent c, String name, ComponentType type) {
        return o.equals(name) && c.getType() == type;
    }
    private DefaultMindmapNode createChild(String name, Object data) {
        return new DefaultMindmapNode(name, data, "82c542", true);
    }
    ...
}
\end{lstlisting}